package net.vtstar.zhongtong.avi.gateway.assembly.job;

import lombok.extern.slf4j.Slf4j;
import net.vtstar.scada.base.equipmgt.domain.Enum.EquipStatusEnum;
import net.vtstar.scada.base.gather.domain.EquipmentData;
import net.vtstar.scada.base.gather.job.GatherJob;
import net.vtstar.zhongtong.avi.gateway.assembly.domain.FocusAddingRefrigerantMachine;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.springframework.stereotype.Component;

import java.util.Date;

/**
 * 冷媒加注机设备数据采集JOB
 */
@Slf4j
@Component
public class FocusAddingRefrigerantMachineJob extends GatherJob {

    private static final String NAME = "FOCUS_ADDING_REFRIGERANT";

    @Override
    protected void executeInternal(JobExecutionContext context) throws JobExecutionException {

        log.info("JobName: {}", context.getJobDetail().getKey().getName());
        super.gatherByModbus(NAME, FocusAddingRefrigerantMachine.class);
    }

    @Override
    public boolean handleObject(EquipmentData equipmentData) {
        FocusAddingRefrigerantMachine data = (FocusAddingRefrigerantMachine) equipmentData;
        String state = data.getStatus();
        if (state == null || "0".equals(state)) {
            return false;
        }
        if (null == data.getFillingSettings() || null == data.getFillingAmount() || null == data.getFillingPressure()
                || data.getFillingSettings() == 0){
            return false;
        }
        equipmentData.setEquipStatus(EquipStatusEnum.RUN);
        return true;
    }

    @Override
    public Object handleValue(String fieldName, Object value) {
        return value;
    }

    @Override
    protected void postHandle(EquipmentData equipmentData) {
        ((FocusAddingRefrigerantMachine)equipmentData).setCreateTime(new Date());
    }
}
